<?php

namespace FiloBlu\Refilo\Remote\Connector;

/**
 * Class FileConnector
 * @package FiloBlu\Refilo\Remote\Connector
 */
class FileConnector extends AbstractConnector {


    protected $filename;

    /**
     * @return mixed|void
     */
    public function disconnect(): ConnectorInterface
    {
        return $this;
    }

    /**
     * @param Traversable $entities
     * @param string $collection
     * @return mixed|void
     */
    public function create(\Traversable $entities, string $collection) {
        $this->getUri();
        file_put_contents($this->filename, json_encode(iterator_to_array($entities), JSON_PRETTY_PRINT));
    }

    /**
     * @return mixed|Manager
     */
    public function connect(): ConnectorInterface
    {$this->getUri();
        return $this;
    }

    /**
     * @param array $entity
     * @param string $collection
     * @return mixed|void
     */
    public function delete(array $entity, string $collection) {

    }

    /**
     * @param Traversable $entities
     * @param string $collection
     * @return mixed|void
     */
    public function update(\Traversable $entities, string $collection) {
        $this->getUri();
        file_put_contents($this->filename,  json_encode(iterator_to_array($entities), JSON_PRETTY_PRINT), FILE_APPEND);

    }


    /**
     * https://tools.ietf.org/html/rfc3986
     * scheme://[username:password@]host1[:port1][,host2[:port2],...[,hostN[:portN]]][/[database][?options]]
     */
    protected function getUri(): string
    {
        $hosts = $this->getConfiguration()->getData(self::CONFIGURATION_HOST_POOL);


        $host = array_shift($hosts);


            $this->filename = $host['path'];


        return '';
    }
}
